(***************************************)
(*       EMS-   *)
(***************************************)

{$A+,B-,E+,F-,I-,N+,O-,Q-,R-,S-}

unit F_EMS;

	INTERFACE

type
  {  ꥪ 娨 }
  PEMSArea = ^TEMSArea;
  TEMSArea = object
    Handle,		{ ਯ }
    MaxPag : Word;	{ ⢮ ࠭ }
    Size : LongInt;	{  ᯮ㥬  }
    constructor Init(ASize : LongInt);
    constructor Load(var F : file);
    destructor Done; virtual;
    procedure EMSError(NError : Byte); virtual;
    procedure Store(var F : file); virtual;
    procedure WriteEMS(var Source;
	Dest, Sz : LongInt); virtual;
    procedure ReadEMS(Source : LongInt;
	var Dest; Sz : LongInt); virtual;
    private
      function ReadFile(var F : file;
	var Dest; Sz : Word) : Boolean; virtual;
      function WriteFile(var F : file;
	var Source; Sz : Word) : Boolean; virtual;
  end;
  {  ᨢ  EMS }
  PEMSVector = ^TEMSVector;
  TEMSVector = object(TEMSArea)
    ItemS,		{   ᨢ }
    MinInd,		{   }
    MaxInd : LongInt;	{ ᨬ  }
    constructor Init(ASize, Min, Max : LongInt);
    constructor Load(var F : file);
    procedure Store(var F : file); virtual;
    procedure SetItem(var Source; Index : LongInt);
    procedure GetItem(var Dest; Index : LongInt);
    function SingleItem(Index : LongInt) : Single;
    function DoubleItem(Index : LongInt) : Double;
    function RealItem(Index : LongInt) : Real;
    function ExtendedItem(Index : LongInt) : Extended;
    function IntegerItem(Index : LongInt) : Integer;
    function LongIntItem(Index : LongInt) : LongInt;
    function ByteItem(Index : LongInt) : Byte;
  end;
  { 㬥 ᨢ  EMS }
  PEMSMatrix = ^TEMSMatrix;
  TEMSMatrix = object(TEMSVector)
    MinInd1,		{   }
    MaxInd1,		{ ᨬ  }
    MinInd2,		{   }
    MaxInd2 : LongInt;	{ ᨬ  }
    constructor Init(ASize, Min1, Max1, Min2, Max2 : LongInt);
    constructor Load(var F : file);
    procedure Store(var F : file); virtual;
    function GetVecIndex(Ind1, Ind2 : LongInt) : LongInt;
    procedure SetItem(var Source; Ind1, Ind2 : LongInt);
    procedure GetItem(var Dest; Ind1, Ind2 : LongInt);
    function SingleItem(Ind1, Ind2 : LongInt) : Single;
    function DoubleItem(Ind1, Ind2 : LongInt) : Double;
    function RealItem(Ind1, Ind2 : LongInt) : Real;
    function ExtendedItem(Ind1, Ind2 : LongInt) : Extended;
    function IntegerItem(Ind1, Ind2 : LongInt) : Integer;
    function LongIntItem(Ind1, Ind2 : LongInt) : LongInt;
    function ByteItem(Ind1, Ind2 : LongInt) : Byte;
  end;
  {  ᨢ  EMS }
  TIndexList = array [1..MaxInt div 2] of LongInt;
  TIndex = array [1..MaxInt div 6, 1..3] of LongInt;
  PIndex = ^TIndex;
  TIndexBond = array [1..MaxInt div 4, 1..2] of LongInt;
  PEMSArray = ^TEMSArray;
  TEMSArray = object(TEMSVector)
    NIndex : Word;	{ ⢮ ७ }
    Index : PIndex;
    constructor Init(ASize : LongInt; NInd : Word; var Ind);
    constructor Load(var F : file);
    destructor Done; virtual;
    procedure Store(var F : file); virtual;
    function GetVecIndex(var Ind) : LongInt;
    procedure SetItem(var Source, Ind);
    procedure GetItem(var Dest, Ind);
  end;
  {  䠩 ᫥⥫쭮 㯠 }
  PEMSType = ^TEMSType;
  TEMSType = object(TEMSArea)
    Pos : LongInt;	{    砫  }
    constructor Init(ASize : Longint);
    constructor Load(var F : file);
    procedure Store(var F : file); virtual;
    procedure SetItem(var Source; Sz : LongInt);
    procedure GetItem(var Dest; Sz : LongInt);
  end;
  {  ⥪⮢ 䠩 }
  PEMSText = ^TEMSText;
  TEMSText = object(TEMSType)
    procedure SetItem(S : string);
    function GetItem : string;
  end;
  {  ࠭  EMS- }
  PEMSScreen = ^TEMSScreen;
  TEMSScreen = object(TEMSArea)
    Mode : Byte;	{  ० }
    constructor Init;
    constructor Load(var F : file);
    procedure Store(var F : file); virtual;
    procedure PutScreen;
    procedure GetScreen;
  end;

var EMSStatus : Byte;	{  ᫥ 樨 }

function IsEMS : Boolean;
{ 頥 true, ᫨    EMS- }

function GetEMMVersion : string;
{ 頥  ᨨ EMM  ଠ 'X.X' }

function EMSSeg : Word;
{ 頥 ᥣ    EMS- }

procedure GetEMSInfo(var AllPage, Pages : Word);
{ 頥  ⢮ (AllPages)
   ⢮  (Pages) ࠭ }

procedure NewEMSHandle(var Handle : Word; Pages : Word);
{ 뢠  ਯ Handle
   뢠   Pages ࠭ EMS }

procedure DisposeEMSHandle(var Handle : Word);
{  ਯ Handle  ᢮
  易    }

procedure MapEMSPage(Handle, Physic, Logic : Word);
{  , 뢠  Physic 䨧 ࠭
   Logic ᪮ ࠭楩 ਯ Handle }

const
  EMSErrorFlag		: Boolean    = false;
  RegHeadTEMSArea	: string[14] = 'F_EMS TEMSArea';
  RegHeadTEMSVector	: string[14] = 'F_EMS TEMSVect';
  RegHeadTEMSMatrix	: string[14] = 'F_EMS TEMSMatr';
  RegHeadTEMSArray	: string[14] = 'F_EMS TEMSArra';
  RegHeadTEMSType	: string[14] = 'F_EMS TEMSType';
  RegHeadTEMSScreen	: string[14] = 'F_EMS TEMSScre';

	IMPLEMENTATION

uses Dos, Graph, F_Text;

var Reg : Registers;

const
  EMSVer : Word = 0;	{  EMM; ᯮ
			   䫠 ஢ન  EMS }
  EMSS : Word = 0;	{   }
  LPage = 16*1024;	{  ࠭ }

constructor TEMSArea.Init(ASize : LongInt);
{  ꥪ TEMSArea.
  ASize - ࠧ ॡ㥬 EMS-   }
var All, Pag : Word;
begin
  if not IsEMS then EMSError($A5) else
  begin
    EMSErrorFlag:=false; Size:=ASize;
    MaxPag:=(Size+LPage-1) shr 14; GetEMSInfo(All,Pag);
    if MaxPag>Pag then EMSError($88) {  ॡ㥬 ࠭ }
    else begin
      NewEMSHandle(Handle,MaxPag); EMSError(EMSStatus)
    end
  end
end;

function TEMSArea.ReadFile(var F : file;
	var Dest; Sz : Word) : Boolean;
{ ⠥ Sz   䠩 F  ६
  Dest  ஫ १ }
var K : Word;
begin
  BlockRead(F,Dest,Sz,K);
  if K<>Sz then
  begin
    EMSError($A7); ReadFile:=false { 訡  ⥭ }
  end
  else ReadFile:=true	{  訡 }
end;

constructor TEMSArea.Load(var F : file);
{  ꥪ TEMSArea, 뢠   䠩 F.
       ⥭     1 
   樮஢  ,  ࠭  ࠭ ꥪ
  TEMSArea 楤ன Store. }
var
  SRead, Rest : LongInt;
  S : string;
  All, k : Word;
  Stop : Boolean;
  P : Pointer;
begin
  if not IsEMS then EMSError($A5) else
  begin
    { ⠥  ꥪ - ப RegHeadTEMSArea }
    EMSErrorFlag:=false;
    Stop:=false; {  ଠ쭮 ⥭ }
    if not ReadFile(F,S,SizeOf(RegHeadTEMSArea))
      or (S<>RegHeadTEMSArea) then
	{ 訡 ⥭  ᮢ  }
	EMSError($A6)
    else { ⠥  MaxPag  Size } begin
      if not (ReadFile(F,MaxPag,2) and ReadFile(F,Size,4))
	then Exit; { 뫠 訡  ⥭  }
      { ஢塞 㯭  }
      GetEMSInfo(All,k);
      if k<MaxPag then
	EMSError($88) {  㦭  } else
      begin
	{ ⠥ ᮧ ਯ }
	NewEMSHandle(Handle,MaxPag);
	if EMSStatus<>0 then EMSError(EMSStatus) else
	begin
	  { ⠥ ᮤন  }
	  Rest:=Size;	{ ⠭ ⮪ }
	  P:=Ptr(EMSSeg,0); {  砫
			      䨧᪮ ࠭  }
	  All:=0; { 稭  0- ᪮ ࠭ }
	  Stop:=false;	{ ਧ 訡 }
	  while (Rest<>0) and not Stop do
	  begin
	    MapEMSPage(Handle,0,All); EMSError(EMSStatus);
	    if EMSStatus<>0 then
	      Exit; { 訡 ஢ }
	    if Rest>LPage then SRead:=LPage else SRead:=Rest;
	    Stop:=not ReadFile(F,P^,SRead);
	    Dec(Rest,SRead); Inc(All)
	  end
	end
      end
    end
  end
end;

function TEMSArea.WriteFile(var F : file;
	var Source; Sz : Word) : Boolean;
{ 뢠 Sz   ६ Source
   䠩 F  ஫ १ }
var K : Word;
begin
  BlockWrite(F,Source,Sz,K);
  if K<>Sz then
  begin
    EMSError($A8); WriteFile:=false { 訡   }
  end
  else WriteFile:=true	{  訡 }
end;

procedure TEMSArea.Store(var F : file);
{ 뢠 ꥪ TEMSArea  䠩 F.   
         1   樮஢
   㦭  (筮 -   䠩) }
var
  SRead, Rest : LongInt;
  S : string;
  All, k : Word;
  Stop : Boolean;
  P : Pointer;
begin
  if not IsEMS then EMSError($A5) else
  begin
    { 뢠  ꥪ - ப RegHeadTEMSArea }
    EMSErrorFlag:=false; S:=RegHeadTEMSArea;
    if WriteFile(F,S,SizeOf(RegHeadTEMSArea)) then
    begin
      { 뢠  MaxPag  Size }
      if WriteFile(F,MaxPag,2) and WriteFile(F,Size,4) then
      begin
	{ 뢠 ᮤন  }
	Rest:=Size;	{ ᠭ ⮪ }
	P:=Ptr(EMSSeg,0); {  砫
			    䨧᪮ ࠭  }
	All:=0; { 稭  0- ᪮ ࠭ }
	Stop:=false;	{ ਧ 訡 }
	while (Rest<>0) and not Stop do
	begin
	  MapEMSPage(Handle,0,All); EMSError(EMSStatus);
	  if EMSStatus<>0 then
	    Exit; { 訡 ஢ }
	  if Rest>LPage then SRead:=LPage else SRead:=Rest;
	  Stop:=not WriteFile(F,P^,SRead);
	  Dec(Rest,SRead); Inc(All)
	end
      end
    end
  end
end;

destructor TEMSArea.Done;
{ ⮦ ꥪ TEMSArea  ᢮
  易    }
begin
  if not IsEMS then EMSError($A5) else
  begin
    DisposeEMSHandle(Handle); EMSError(EMSStatus)
  end
end;

procedure TEMSArea.WriteEMS(var Source; Dest, Sz : LongInt);
{ 뢠 Sz   ६ Source  EMS,
  稭  樨 Dest    砫 }
var
  Rest, Pos, k : LongInt;
  Pag : Word;
  PD, PS : Pointer;
  PW : record
    S, O : Word
  end absolute PS;
  Stop : Boolean;
begin
  {$ifNdef NotCheck}
    if (Sz<0) or (Dest+Sz>Size) then
      EMSError($AA) {   ࠭楩  } else
  {$endif}
  begin
    Pag:=Dest div LPage;	{ ᪠ ࠭ }
    Pos:=Dest mod LPage;	{ 饭   }
    PS:=@Source;		{ ⥫  筨 }
    PD:=Ptr(EMSS,Pos);		{ ⥫  EMS }
    Stop:=false;		{  訡 ஢ }
    Rest:=Sz;			{ ⮪  }
    repeat
      {   ࠭栬 EMS }
      MapEMSPage(Handle,0,Pag); { 㥬  }
      EMSError(EMSStatus);
      Stop:=EMSStatus<>0;	{ ਧ 訡 }
      if not Stop then
      begin
	{ ।塞 ࠧ Sz ।  }
	if Rest>LPage-Pos then Sz:=LPage-Pos else Sz:=Rest;
	Move(PS^,PD^,Sz);	{ ७ᨬ  }
	Dec(Rest,Sz);		{ 蠥 ⮪ }
	Inc(Pag);		{  ᪠ . }
	PD:=Ptr(EMSS,0);	{ ⥫ -   砫 }
	Pos:=0; Inc(PW.O,Sz);	{ 饭  筨 }
	{ ଠ㥬 㪠⥫ PS 筨 }
	PW.S:=PW.S+(PW.O shr 4); PW.O:=PW.O mod 16
      end
    until Stop or (Rest=0)
  end
end;

procedure TEMSArea.ReadEMS(Source : LongInt;
	var Dest; Sz : LongInt);
{ ⠥ Sz   EMS-, 稭  
  Source   砫  ६ Dest }
var
  Rest, Pos, k : LongInt;
  Pag : Word;
  PD, PS : Pointer;
  PW : record
    S, O : Word
  end absolute PD;
  Stop : Boolean;
begin
  {$ifNdef NotCheck}
    if (Sz<0) or (Source+Sz>Size) then
      EMSError($A9) { ⥭  ࠭楩  } else
  {$endif}
  begin
    Pag:=Source div LPage;	{ ᪠ ࠭ }
    Pos:=Source mod LPage;	{ 饭   }
    PD:=@Dest;			{ ⥫  ਥ }
    PS:=Ptr(EMSS,Pos);		{ ⥫  筨 }
    Stop:=false;		{  訡 ஢ }
    Rest:=Sz;			{ ⮪ ⥭ }
    repeat
      {   ࠭栬 EMS }
      MapEMSPage(Handle,0,Pag); { 㥬  }
      EMSError(EMSStatus);
      Stop:=EMSStatus<>0;	{ ਧ 訡 }
      if not Stop then
      begin
	{ ।塞 ࠧ Sz ।  }
	if Rest>LPage-Pos then Sz:=LPage-Pos else Sz:=Rest;
	Move(PS^,PD^,Sz);	{ ७ᨬ  }
	Dec(Rest,Sz);		{ 蠥 ⮪ }
	Inc(Pag);		{  ᪠ . }
	PS:=Ptr(EMSS,0); Pos:=0;
	Inc(PW.O,Sz);		{ 饭  ਥ }
	{ ଠ㥬 㪠⥫ PD ਥ }
	PW.S:=PW.S+(PW.O shr 4); PW.O:=PW.O mod 16
      end
    until Stop or (Rest=0)
  end
end;

procedure TEMSArea.EMSError(NError : Byte);
{ 砥 ࠢ  訡 EMM 
   믮 ⮤ ꥪ.  㬮砭
  뢮 ᮮ饭  ஬ NError }
const Msg : array [$80..$AD] of string[73] = (
  '७ 訡 EMM',
  ' EMS-',
  'EMM  ࠡ⪮ ।饣 ',
  ' ਯ ',
  '襭 ।   ᨨ EMM 㭪',
  ' 㯭 ਯ஢ ',
  '訡  ࠭  ⠭ ',
  ' । ॢ蠥  EMS-',
  ' । ॢ蠥 ᫮ 㯭 ࠭',
  '⪠ ᮧ ਯ  㫥 ⢮ ࠭',
  'ਯ  ᯮ ⠪ ᫮ ࠭',
  '⪠ ஢  4 ࠭',
  '९  ࠭ 饣 ⥪',
  '⪠ ୮ ࠭ 饣 ⥪',
  '⪠ ⠭ ࠭ ⥪',
  ' । ࠬ 㭪樨',
  ' ⨯ ਡ⮢',
  ' ⭮ প ࠭塞 ࠭',
  '筨  ਥ ଠ樨 ६ '+
	'室  EMS-',
  ' ਥ ଠ樨 ᫨誮 ',
  '⠭⭠  筮 ४뢠 '+
	'७ ',
  '誮 讥 ᬥ饭  ६頥 ',
  ' ६頥   1 ',
  '筨  ਥ 易   ਯ஬  '+
	'筮 ४뢠',
  '⨬ ⨯  筨  ਥ',
  ' 訡',
  ' ⭮ প ୠ⨢ ⠭ ࠭',
  '௠  ⨬ ⠭ ୠ⨢ '+
	'ॣ஢',
  ' ন ⠭ ୠ⨢ ॣ஢',
  'ࠢ쭠 ⠭ ୠ⨢ ॣ஢',
  '祭  אַ 㯠   () '+
	' ন',
  '   ন',
  'ਯ  ',
  '  ਯ 㦥 ',
  '筨 室  ࠭ 1 ',
  'ন 㪠   ࠧ襭',
  ' 㯠  㪠 㭪樨',
  ' EMS-   ⠭ ࠩ EMM.SYS',
  ' ଠ 䠩',
  '訡  ⥭ ꥪ  䠩',
  '訡   ꥪ  䠩',
  '⪠ ⥭  ࠭楩 㯭 EMS-',
  '⪠   ࠭楩 㯭 EMS-',
  ' ࠭ ᮢ',
  '    ᮮ⢥  ६',
  ' ० ࠡ ᯫ (ꥪ TEMSScreen)');
begin
  if NError=0 then
  begin
    EMSErrorFlag:=false; Exit
  end;
  EMSErrorFlag:=true;
  if NError in [$80..$AD] then WriteLn(Msg[NError])
    else WriteLn('訡  ',NError)
end;

constructor TEMSVector.Init(ASize, Min, Max : LongInt);
{  ꥪ TEMSVector:
	ASize	 - ࠧ ⮢ ᨢ  
	Min, Max - ࠭  }
var Sz : LongInt;
begin
  if Min>Max then
  begin
    EMSError($AB); { ࠢ ࠭ } Exit
  end;
  Sz:=ASize*(Max-Min+1);	{ ।塞 ࠧ }
  TEMSArea.Init(Sz);		{  TEMSArea }
  if not EMSErrorFlag then
  begin
    ItemS:=ASize; MinInd:=Min; MaxInd:=Max
  end
end;

constructor TEMSVector.Load(var F : file);
{  ꥪ TEMSVector - ⠥  䠩
   ꥪ TEMSArea, ⥬  
   ItemS, MinInd, MaxInd }
var S : string;
begin
  TEMSArea.Load(F); { 㦠  䠩  ꥪ }
  if not EMSErrorFlag then
    if ReadFile(F,S,SizeOf(RegHeadTEMSVector))
      and (S=RegHeadTEMSVector) then
  begin
    if ReadFile(F,ItemS,4) then
      if ReadFile(F,MinInd,4) then ReadFile(F,MaxInd,4);
    if EMSErrorFlag then Done
  end
  else EMSError($A6)
end;

procedure TEMSVector.Store(var F : file);
{ ࠭   䠩 - ᭠砫 ࠭ 
  ꥪ, ⮬    ItemS, MinInd, MaxInd }
begin
  TEMSArea.Store(F);
  if not EMSErrorFlag then
  begin
    if WriteFile(F,RegHeadTEMSVector,
      SizeOf(RegHeadTEMSVector)) then if WriteFile(F,ItemS,4)
	then if WriteFile(F,MinInd,4) then
	  WriteFile(F,MaxInd,4)
  end
end;

procedure TEMSVector.SetItem(var Source; Index : LongInt);
{ 頥  EMS   ᮬ Index
   ६ Source }
begin
  {$ifNdef NotCheck}
    if (Index>MaxInd) or (Index<MinInd) then
      EMSError($AB) { ࠢ  } else
  {$endif}
  WriteEMS(Source,(Index-MinInd)*ItemS,ItemS)
end;

procedure TEMSVector.GetItem(var Dest; Index : LongInt);
{ ⠥  EMS  ᨢ  ᮬ Index }
begin
  {$ifNdef NotCheck}
    if (Index>MaxInd) or (Index<MinInd) then
      EMSError($AB) else
  {$endif}
  ReadEMS((Index-MinInd)*ItemS,Dest,ItemS)
end;

function TEMSVector.SingleItem(Index : LongInt) : Single;
var X : Single;
begin
  {$ifNdef NotCheck}
    if ItemS<>SizeOf(Single) then
      EMSError($AC) { 訡    } else
  {$endif}
  begin
    GetItem(X,Index); SingleItem:=X
  end
end;

function TEMSVector.DoubleItem(Index : LongInt) : Double;
var X : Double;
begin
  {$ifNdef NotCheck}
    if ItemS<>SizeOf(Double) then EMSError($AC) else
  {$endif}
  begin
    GetItem(X,Index); DoubleItem:=X
  end
end;

function TEMSVector.RealItem(Index : LongInt) : Real;
var X : Real;
begin
  {$ifNdef NotCheck}
    if ItemS<>SizeOf(Real) then EMSError($AC) else
  {$endif}
  begin
    GetItem(X,Index); RealItem:=X
  end
end;

function TEMSVector.ExtendedItem(Index : LongInt) : Extended;
var X : Extended;
begin
  {$ifNdef NotCheck}
    if ItemS<>SizeOf(Extended) then EMSError($AC) else
  {$endif}
  begin
    GetItem(X,Index); ExtendedItem:=X
  end
end;

function TEMSVector.IntegerItem(Index : LongInt) : Integer;
var X : Integer;
begin
  {$ifNdef NotCheck}
    if ItemS<>SizeOf(Integer) then EMSError($AC) else
  {$endif}
  begin
    GetItem(X,Index); IntegerItem:=X
  end
end;

function TEMSVector.LongIntItem(Index : LongInt) : LongInt;
var X : LongInt;
begin
  {$ifNdef NotCheck}
    if ItemS<>SizeOf(LongInt) then EMSError($AC) else
  {$endif}
  begin
    GetItem(X,Index); LongIntItem:=X
  end
end;

function TEMSVector.ByteItem(Index : LongInt) : Byte;
var X : Byte;
begin
  {$ifNdef NotCheck}
    if ItemS<>SizeOf(Byte) then EMSError($AC) else
  {$endif}
  begin
    GetItem(X,Index); ByteItem:=X
  end
end;

constructor TEMSMatrix.Init(ASize, Min1, Max1,
	Min2, Max2 : LongInt);
{  ꥪ TEMSMatrix:
	ASize	 - ࠧ ⮢ ᨢ  
	Min, Max - ࠭  }
var Sz : LongInt;
begin
  if (Min1>Max1) or (Min2>Max2) then
  begin
    EMSError($AB); Exit
  end;
  { ८ࠧ㥬  ୮ ᨢ  0 }
  Sz:=(Max1-Min1+1)*(Max2-Min2+1)-1;
  TEMSVector.Init(Asize,0,Sz);
  if not EMSErrorFlag then
  begin
    MinInd1:=Min1; MaxInd1:=Max1;
    MinInd2:=Min2; MaxInd2:=Max2
  end
end;

constructor TEMSMatrix.Load(var F : file);
{  ꥪ TEMSMatrix - ⠥  䠩
  ꥪ TEMSVector, ⥬  
   MinInd1, MaxInd1, MinInd2, MaxInd2 }
var S : string;
begin
  TEMSVector.Load(F); { 㦠  䠩 ꥪ-த⥫ }
  if not EMSErrorFlag then
    if ReadFile(F,S,SizeOf(RegHeadTEMSMatrix))
      and (S=RegHeadTEMSMatrix) then
  begin
    if ReadFile(F,MinInd1,4) and ReadFile(F,MaxInd1,4) and
      ReadFile(F,MinInd2,4) then ReadFile(F,MaxInd2,4);
    if EMSErrorFlag then Done
  end
  else EMSError($A6)
end;

procedure TEMSMatrix.Store(var F : file);
{ ࠭   䠩 - ᭠砫 ࠭
  த⥫᪨ ꥪ TEMSVector, ⮬ 
    MinInd1, MaxInd1, MinInd2, MaxInd2 }
begin
  TEMSVector.Store(F);
  if not EMSErrorFlag then
  begin
    if WriteFile(F,RegHeadTEMSMatrix,
      SizeOf(RegHeadTEMSMatrix)) then
	if WriteFile(F,MinInd1,4) then
	  if WriteFile(F,MaxInd1,4) then
	    if WriteFile(F,MinInd2,4) then
	      WriteFile(F,MaxInd2,4)
  end
end;

function TEMSMatrix.GetVecIndex(Ind1,
	Ind2 : LongInt) : LongInt;
{ ८ࠧ  㬥୮ ᨢ
    ୮  0 }
begin
  EMSErrorFlag:=false;
  {$ifNdef NotCheck}
    if (Ind1>MaxInd1) or (Ind1<MinInd1) or
      (Ind2>MaxInd2) or (Ind2<MinInd2) then
	EMSError($AB) else
  {$endif}
  GetVecIndex:=(Ind1-MinInd1)*(MaxInd2-MinInd2)+Ind2-MinInd2
end;

procedure TEMSMatrix.SetItem(var Source;
	Ind1, Ind2 : LongInt);
{ 頥  EMS   ᠬ
  Ind1, Ind2  ६ Source }
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  TEMSVector.SetItem(Source,Item)
end;

procedure TEMSMatrix.GetItem(var Dest;
	Ind1, Ind2 : LongInt);
{ ⠥  EMS  ᨢ  ᠬ Ind1, Ind2 }
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  TEMSVector.GetItem(Dest,Item)
end;

function TEMSMatrix.SingleItem(Ind1,
	Ind2 : LongInt) : Single;
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  SingleItem:=TEMSVector.SingleItem(Item)
end;

function TEMSMatrix.DoubleItem(Ind1,
	Ind2 : LongInt) : Double;
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  DoubleItem:=TEMSVector.DoubleItem(Item)
end;

function TEMSMatrix.RealItem(Ind1, Ind2 : LongInt) : Real;
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  RealItem:=TEMSVector.RealItem(Item)
end;

function TEMSMatrix.ExtendedItem(Ind1,
	Ind2 : LongInt) : Extended;
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  ExtendedItem:=TEMSVector.ExtendedItem(Item)
end;

function TEMSMatrix.IntegerItem(Ind1,
	Ind2 : LongInt) : Integer;
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  IntegerItem:=TEMSVector.IntegerItem(Item)
end;

function TEMSMatrix.LongIntItem(Ind1,
	Ind2 : LongInt) : LongInt;
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  LongIntItem:=TEMSVector.LongIntItem(Item)
end;

function TEMSMatrix.ByteItem(Ind1, Ind2 : LongInt) : Byte;
var Item : LongInt;
begin
  Item:=GetVecIndex(Ind1,Ind2);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  ByteItem:=TEMSVector.ByteItem(Item)
end;

constructor TEMSArray.Init(ASize : LongInt;
	NInd : Word; var Ind);
{  ꥪ TEMSArray: ᭠砫 ᮧ 
  ꥪ TEMSVector  ᮬ  0, ⥬ 
   NInde, १ࢨ    Index 
    ࠭栬 ᮢ }
var
  Indx : TIndexBond absolute Ind;
  Sz : LongInt;
  k, j : Word;
begin
  { ।塞 饥 ⢮ Sz ⮢ ᨢ }
  Sz:=0; EMSErrorFlag:=false;
  for k:=1 to NInd do if Indx[k,1]>Indx[k,2] then
    EMSError($AB) else Sz:=Sz+Indx[k,2]-Indx[k,1]+1;
  if not EMSErrorFlag then
  begin
    {   ꥪ TEMSVector }
    TEMSVector.Init(ASize,0,Sz-1);
    if not EMSErrorFlag then
    begin
      GetMem(Index,NInd*12);
      { 塞 ⥫  ७
	 ନ㥬 ᯨ᮪ ࠭ Index^ }
      Index^[NInd,3]:=1; { 訩  }
      Index^[NInd,1]:=Indx[NInd,1];
      Index^[NInd,2]:=Indx[NInd,2];
      for k:=NInd-1 downto 1 do
      begin
	Index^[k,1]:=Indx[k,1];
	Index^[k,2]:=Indx[k,2]; Sz:=0;
	for j:=k+1 to NInd do
	  Sz:=Sz+(Index^[j,2]-Index^[j,1]+1)*Index^[j,3];
	Index^[k,3]:=Sz
      end;
      NIndex:=NInd
    end
  end
end;

destructor TEMSArray.Done;
{ ⮦ ꥪ TEMSArray - 㭨⮦ 
  ꥪ TEMSVector  ᢮  Index^ }
begin
  TEMSVector.Done; FreeMem(Index,NIndex*12)
end;

constructor TEMSArray.Load(var F : file);
{ 㦠 ꥪ TEMSArray  䠩 F - ᭠砫 㦠
   ꥪ TEMSVector, ⥬ ⠥ 
  RegHeadTEMSArray,  NIndex  ᯨ᮪ ࠭ ᮢ }
var
  S : string;
  k, j : Integer;
begin
  TEMSVector.Load(F);
  if not EMSErrorFlag then
    if ReadFile(F,S,SizeOf(RegHeadTEMSArray)) and
      (S=RegHeadTEMSArray) and ReadFile(F,NIndex,2) then
  begin
    GetMem(Index,NIndex*12);
    for k:=1 to NIndex do
    begin
      ReadFile(F,Index^[k,1],4);
      ReadFile(F,Index^[k,2],4); ReadFile(F,Index^[k,3],4)
    end;
    if EMSErrorFlag then Done
  end
  else begin
    EMSError($A6); TEMSVector.Done
  end
end;

procedure TEMSArray.Store(var F : file);
{ ࠭ ꥪ TEMSArray  䠩 - ࠭
   ꥪ TEMSVector, ⥬  ,
   NIndex  ᯨ᮪ ࠭ ᮢ }
var k : Word;
begin
  TEMSVector.Store(F);
  if not EMSErrorFlag then
    if WriteFile(F,RegHeadTEMSArray,SizeOf(RegHeadTEMSArray))
      and WriteFile(F,NIndex,4) then for k:=1 to NIndex do
  begin
    WriteFile(F,Index^[k,1],4);
    WriteFile(F,Index^[k,2],4); WriteFile(F,Index^[k,3],4)
  end
end;

function TEMSArray.GetVecIndex(var Ind) : LongInt;
{  ⥪騬 祭 ᯨ᪠ ᮢ Ind
     ꥪ TEMSVector }
var
  Indx : TIndexList absolute Ind;
  N : Longint;
  k : Word;
begin
  EMSErrorFlag:=false; N:=0;
  for k:=1 to NIndex do
  {$ifNdef NotCheck}
    if (Indx[k]<Index^[k,1]) or (Indx[k]>Index^[k,2]) then
      EMSErrorFlag:=true else
  {$endif}
  N:=N+(Indx[k]-Index^[k,1])*Index^[k,3];
  if EMSErrorFlag then EMSError($AB) else GetVecIndex:=N-1
end;

procedure TEMSArray.SetItem(var Source, Ind);
{ 頥 祭 Source   ୮ ᨢ }
var N : LongInt;
begin
  N:=GetVecIndex(Ind);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  TEMSVector.SetItem(Source,N)
end;

procedure TEMSArray.GetItem(var Dest, Ind);
{ 頥  ६ Dest  ୮ ᨢ }
var N : LongInt;
begin
  N:=GetVecIndex(Ind);
  {$ifNdef NotCheck}
    if not EMSErrorFlag then
  {$endif}
  TEMSVector.GetItem(Dest,N)
end;

constructor TEMSType.Init(ASize : LongInt);
{  ꥪ TEMSType: ᭠砫 ᮧ 
  ꥪ TEMSArea, ⥬   Pos }
begin
  TEMSArea.Init(ASize); Pos:=0
end;

constructor TEMSType.Load(var F : file);
{ 뢠 ꥪ TEMSType  䠩 F }
var S : string;
begin
  TEMSArea.Load(F);
  if not EMSErrorFlag then
    if ReadFile(F,S,SizeOf(RegHeadTEMSType)) and
      (S=RegHeadTEMSType) then ReadFile(F,Pos,4) else Done
end;

procedure TEMSType.Store(var F : file);
{ 뢠 ꥪ  䠩 }
begin
  TEMSArea.Store(F);
  if not EMSErrorFlag and
    WriteFile(F,RegHeadTEMSType,SizeOf(RegHeadTEMSType))
      then WriteFile(F,Pos,4)
end;

procedure TEMSType.SetItem(var Source; Sz : LongInt);
{ 뢠  TEMSType ।  }
begin
  WriteEMS(Source,Pos,Sz);
  if not EMSErrorFlag then Inc(Pos,Sz)
end;

procedure TEMSType.GetItem(var Dest; Sz : LongInt);
{ ⠥  TEMSType ।  }
begin
  ReadEMS(Pos,Dest,Sz);
  if not EMSErrorFlag then Inc(Pos,Sz)
end;

procedure TEMSText.SetItem(S : string);
{ 頥  EMS- (稭  樨
  Pos   砫) ப S }
begin
  TEMSType.SetItem(S,Length(S)+1)
end;

function TEMSText.GetItem : string;
{ ⠥  EMS- । ப }
var
  L : Byte;
  S : string;
begin
  TEMSType.GetItem(L,1);
  if not EMSErrorFlag then
  begin
    S[0]:=Chr(L); TEMSType.GetItem(S[1],L); GetItem:=S
  end
  else GetItem:=#26
end;

constructor TEMSScreen.Init;
{  ꥪ - । ⥪騩 ०
  ࠡ    ᨬ  ⮣
  १ࢨ  㦭 ࠧ }
var Sz : LongInt;
begin
  {   㭪樨 $F 뢠 $10 ।塞
    ⥪騩 ० ࠡ ࠭ }
  with Reg do
  begin
    ah:=$F; Intr($10,Reg); Mode:=al
  end;
  { 롨ࠥ 㦭 ࠧ 
      1..7 - ⥪⮢ ०  䨪 CGA, 16 =1
      13, 14 -   EGA/VGA 䨪 CGA, 16 =1
      15 -  EGA 640x350, 28  = 2 .
      16 - 梥 EGA 640x350, 112  = 7 .
      17 -  VGA 640x480, 38.4  = 3 .
      18 - 梥 VGA 640x480, 153.6  = 10 . }
  case Mode of
    1..7, 13..14: Sz:=LPage; 15: Sz:=2*LPage;
    16: Sz:=7*LPage; 17: Sz:=3*LPage; 18: Sz:=10*LPage
    else Sz:=24*LPage {  SVGA }
  end;
  TEMSArea.Init(Sz)
end;

constructor TEMSScreen.Load(var F : file);
{ ⠥ ꥪ  䠩 }
var S : string;
begin
  TEMSArea.Load(F);
  if not EMSErrorFlag then
    if ReadFile(F,S,SizeOf(RegHeadTEMSScreen))
      and (S=RegHeadTEMSScreen) then
	ReadFile(F,Mode,1) else Done
end;

procedure TEMSScreen.Store(var F : file);
{ ࠭ ꥪ  䠩 }
begin
  TEMSArea.Store(F);
  if not EMSErrorFlag then
    if WriteFile(F,RegHeadTEMSScreen,SizeOf(TEMSScreen))
      then WriteFile(F,Mode,1)
end;

procedure TEMSScreen.PutScreen;
{ 뢠  EMS-  ࠭ }
var
  x, y, xx, yy, dy : Integer;
  Pag : Byte;
  EMS, Video : Pointer;
begin
  { ஢塞 ⥪騩 ० }
  with Reg do
  begin
    ah:=$F; Intr($10,Reg);
    if al<>Mode then
    begin
      {   ᮮ⢥ Mode - ᮮ頥  室 }
      EMSError($AD); Exit
    end
  end;
  { 㥬   ᨬ  ० }
  EMS:=Ptr(EMSS,0); { 砫 EMS }
  case Mode of
    1..6, 13..14: begin
      { ⮢ ०  ஢,
	஬ MDA, 䨪 CGA   :
	砫   $B800,   16  }
      Video:=Ptr($B800,0); MapEMSPage(Handle,0,0);
      if not EMSErrorFlag then
	MoveFromScreen(Video^,EMS^,LPage)
    end;
    7: begin
      { ⮢ ० MDA:
	砫   $B000,  4  }
      Video:=Ptr($B000,0); MapEMSPage(Handle,0,0);
      if not EMSErrorFlag then
	MoveFromScreen(Video,EMS,LPage div 4)
    end;
    else begin
      { ⠫ ᯫ: ।,   EGA,
	VGA  SVGA  ᪮ ० }
      x:=0; xx:=GetMaxX;	{  孨 㣮 }
      y:=0; yy:=0;		{ ࠢ  㣮 }
      Pag:=0;			{  砫쭮 . EMS }
      { ।塞 ⢮ dy  ப ࠭, 
	 㬥    ࠭ EMS }
      while (ImageSize(x,y,xx,yy)<LPage) and
	(yy<=GetMaxY) do Inc(yy);
      dy:=yy-1;
      { ᭮ 横 ࠭    16 }
      repeat
	{ 㥬 ࠭  }
	MapEMSPage(Handle,0,Pag);
	{ 砥   ࠭ }
	if y+dy<=GetMaxY then GetImage(x,y,xx,y+dy,EMS^)
	  else GetImage(x,y,xx,GetMaxY,EMS^);
	Inc(Pag); Inc(y,dy)
      until y>=GetMaxY
    end
  end
end;

procedure TEMSScreen.GetScreen;
{ 砥  EMS-  ࠭ }
var
  x, y, xx, yy, dy : Integer;
  Pag : Byte;
  EMS, Video : Pointer;
begin
  with Reg do
  begin
    ah:=$F; Intr($10,Reg);
    if al<>Mode then
    begin
      EMSError($AD); Exit
    end
  end;
  EMS:=Ptr(EMSS,0);
  case Mode of
    1..6, 13..14: begin
      Video:=Ptr($B800,0); MapEMSPage(Handle,0,0);
      if not EMSErrorFlag then
	MoveToScreen(EMS^,Video^,LPage)
    end;
    7: begin
      Video:=Ptr($B000,0); MapEMSPage(Handle,0,0);
      if not EMSErrorFlag then
	MoveToScreen(EMS,Video,LPage div 4)
    end;
    else begin
      x:=0; xx:=GetMaxX; y:=0; yy:=0; Pag:=0;
      while (ImageSize(x,y,xx,yy)<LPage) and
	(yy<=GetMaxY) do Inc(yy);
      dy:=yy-1;
      repeat
	MapEMSPage(Handle,0,Pag);
	PutImage(x,y,EMS^,NormalPut);
	Inc(Pag); Inc(y,dy)
      until y>=GetMaxY
    end
  end
end;

procedure Intr67;
{  뢠 $67  ⠭ 䫠 EMSStatus }
begin
  Intr($67,Reg); EMSStatus:=Reg.ah
end;

function IsEMS : Boolean;
const
  Name : array [1..9] of Char = 'EMMXXXX0'#0;
label Exit;
begin
  if EMSVer=0 then with Reg do
  begin
    {  뫮 ஢ન ࠭ - ஢塞 ⠭ EMM }
    ah:=$3D;	{  ਯ 䠩 }
    al:=0;	{  ⥭ }
    dx:=Ofs(Name); ds:=Seg(Name); {   "EMMXXXX0" }
    MsDos(Reg);
    { ᫨ 䠩  - EMM  ⠭ }
    if Flags and FCarry<>0 then goto Exit;
    { ஢塞  䠩 }
    bx:=ax;	{ ਯ 䠩 }
    ah:=$44;	{  IOCTL }
    al:=7;	{   䠩 }
    MsDos(Reg);
    if ((Flags and FCarry)<>0) or (al=0) then goto Exit;
    ah:=$46; { 砥  ᨨ EMM }
    Intr67;
    if EMSStatus=0 then
    { ᫨ 訡 -  EMM }
    begin
      EMSVer:=al;	{ ࠭塞  ᨨ }
      ah:=$41;		{ 砥 ᥣ  }
      Intr67;
      EMSS:=bx		{ ࠭塞 ᥣ }
    end
  end;
  Exit: IsEMS:=EMSVer<>0
end;

function GetEMMVersion : string;
var s, ss : string;
begin
  if EMSVer=0 then if IsEMS then;
  Str(EMSVer shr 4,s);
  Str(EMSVer and $F,ss); GetEMMVersion:=s+'.'+ss
end;

function EMSSeg : Word;
begin
  if EMSS=0 then if IsEMS then;
  EMSSeg:=EMSS
end;

procedure GetEMSInfo(var AllPage, Pages : Word);
begin
  if IsEMS then with Reg do
  begin
    ah:=$42; Intr67; AllPage:=dx; Pages:=bx
  end
  else begin
    AllPage:=0; Pages:=0
  end
end;

procedure NewEMSHandle(var Handle : Word; Pages : Word);
begin
  if IsEMS then with Reg do
  begin
    ah:=$43; bx:=Pages; Intr67; Handle:=dx
  end
end;

procedure DisposeEMSHandle(var Handle : Word);
begin
  if IsEMS then with Reg do
  begin
    ah:=$45; dx:=Handle; Intr67
  end
end;

procedure MapEMSPage(Handle, Physic, Logic : Word);
const
  { ࠬ ।饣 饭  楤 }
  OldH : Word = $FFFF;
  OldL : Word = $FFFF;
  OldP : Word = $FFFF;
begin
  asm
    { ஢塞 ࠬ 饭: ᫨ 
       﫨,  ⥪ ࠭
      ࠭    ஢ }
	mov	ax,Physic
	mov	bx,Logic
	mov	dx,Handle
	cmp	ax,OldP
	jne	@do	{  䨧. . }
	cmp	bx,OldL
	jne	@do	{  . . }
	cmp	dx,OldH
	je	@Exit	{ ࠬ  﫨,
			   㦭 ஢  ࠧ }
  @do:	{ ࠬ  - 㥬 }
	mov	OldP,ax
	mov	OldL,bx
	mov	OldH,dx
	mov	ah,$44
	int	$67
	mov	EMSStatus,ah	{   EMS }
  @Exit:
  end
end;

end { F_EMS }.